' Code is generated by Telerik Add OpenAccess Service Wizard
' using WebApiController.tt template

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Net.Http
Imports System.Web
Imports System.Web.Http
Imports OpenAccessModel

Namespace WebApplication

    ''' <summary>
    ''' Web API Controller for Categories entity defined in Global.OpenAccessModel.EntitiesModel data model
    ''' </summary>
    Partial Public Class CategoriesController
        Inherits OpenAccessBaseApiController(Of Global.OpenAccessModel.Category, Global.OpenAccessModel.EntitiesModel)

        ''' <summary>
        ''' Constructor used by the Web API infrastructure.
        ''' </summary>
        Public Sub New()
            Me.repository = New CategoryRepository()
        End Sub

        ''' <summary>
        ''' Dependency Injection ready constructor.
        ''' Usable also for unit testing.
        ''' </summary>
        ''' <remarks>Web API Infrastructure will ALWAYS use the default constructor!</remarks>
        ''' <param name="repository">Repository instance of the specific type</param>
        Public Sub New(repository As IOpenAccessBaseRepository(Of Global.OpenAccessModel.Category, Global.OpenAccessModel.EntitiesModel))
            Me.repository = repository
        End Sub



        ' Get all method is implemented in the base class

        ''' <summary>
        ''' Gets single instance by it's primary key
        ''' </summary>
        ''' <param name="id">Primary key value to filter by</param>
        ''' <returns>Entity instance if a matching entity is found</returns>
        Public Overridable Function GetById(id As Int32) As Global.OpenAccessModel.Category

            Dim entity As Global.OpenAccessModel.Category = repository.GetBy(Function(g) g.CategoryID = id ) 

            If entity Is Nothing Then
                Throw New HttpResponseException(HttpStatusCode.NotFound)
            End If

            Return entity
        End Function


                
        ''' <summary>
        ''' Updates single entity.
        ''' </summary>
        ''' <remarks>Replaces the whole existing entity with the provided one</remarks>
        ''' <param name="id">ID of the entity to update</param>
        ''' <param name="entity">Entity with the new updated values</param>
        ''' <returns>HttpStatusCode.BadRequest if ID parameter does not match the ID value of the entity,
        ''' or HttpStatusCode.NoContent if the operation was successful</returns>
        Public Overridable Function Put(id As Int32, entity As Global.OpenAccessModel.Category) As HttpResponseMessage
        
                    If entity Is Nothing OrElse id <> entity.CategoryID  Then 
                Throw New HttpResponseException(HttpStatusCode.BadRequest)
            End If
        
            repository.Update(entity)
        
            Return Request.CreateResponse(HttpStatusCode.NoContent)
                End Function
        
        ''' <summary>
        ''' Deletes an entity by it's Id
        ''' </summary>
        ''' <param name="id">ID of the entity to delete</param>
        ''' <returns>Always HttpStatusCode.OK</returns>
        Public Overridable Function Delete(id As Int32) As HttpResponseMessage
        
                    Dim entity As Global.OpenAccessModel.Category = repository.GetBy(Function(g) g.CategoryID = id )
            If entity IsNot Nothing Then
                repository.Delete(entity)
            End If
        
            ' According to the HTTP specification, the DELETE method must be idempotent, 
            ' meaning that several DELETE requests to the same URI must have the same effect as a single DELETE request. 
            ' Therefore, the method should not return an error code if the product was already deleted.
            Return New HttpResponseMessage(HttpStatusCode.OK)
                End Function

        ''' <summary>
        ''' Creates the response sent back to client after a new entity is successfully created.
        ''' </summary>
        ''' <param name="httpStatusCode">Status code to return</param>
        ''' <param name="entityToEmbed">Entity instance to embed in the response</param>
        ''' <returns>HttpResponseMessage with the provided status code and object to embed</returns>
        Protected Overrides Function CreateResponse(httpStatusCode As HttpStatusCode, entityToEmbed As Global.OpenAccessModel.Category) As HttpResponseMessage

            Dim response As HttpResponseMessage = Request.CreateResponse(Of Global.OpenAccessModel.Category)(httpStatusCode, entityToEmbed)

            Dim uri As String = Url.Link("DefaultApi", New With { _
             .id = entityToEmbed.CategoryID _ 
            })
            response.Headers.Location = New Uri(uri)

            Return response
        End Function

    End Class
End Namespace
