﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Http
Imports WebApplication.System.Linq.Dynamic
Imports System.Net.Http
Imports System.Reflection
Imports System.Net
Imports Telerik.OpenAccess

Namespace WebApplication
    Partial Public MustInherit Class OpenAccessBaseApiController(Of TEntity, TContext As {OpenAccessContext, New})
        Inherits ApiController

        Public Function GetAll(ByVal skip As Integer, ByVal take As Integer) As HttpResponseMessage
            Return Me.GetAll(skip, take, Nothing)
        End Function

        Public Function GetAll(ByVal skip As Integer, ByVal take As Integer, ByVal orderBy As String) As HttpResponseMessage
            Dim resultQuery As IQueryable(Of TEntity) = Me.repository.GetAllWithoutDetaching()
            Dim totalNumberOfRecords As Long = resultQuery.Count()

            If String.IsNullOrWhiteSpace(orderBy) = False Then
                Try
                    resultQuery = resultQuery.OrderBy(orderBy)
                Catch ex As ParseException
                    ' when some of the order by parameters is invalid
                    Return Request.CreateResponse(HttpStatusCode.BadRequest, ex.Message)
                End Try
            End If

            resultQuery = resultQuery.Skip(skip).Take(take)
            Dim detachedResults As IEnumerable(Of TEntity) = Me.repository.DetachEntities(resultQuery)
            Dim responseContent As New PagingResponse(Of TEntity)(detachedResults, totalNumberOfRecords)

            Return Request.CreateResponse(HttpStatusCode.OK, responseContent)
        End Function
    End Class
End Namespace
