' Code is generated by Telerik Add OpenAccess Service Wizard
' using WebApiRepositories.tt template

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Linq.Expressions
Imports Telerik.OpenAccess
Imports Telerik.OpenAccess.FetchOptimization

Namespace WebApplication

    Public Interface IOpenAccessBaseRepository(Of TEntity, TContext As {OpenAccessContext, New})

        Function GetAll() As IQueryable(Of TEntity)
        Function GetBy(filter As Expression(Of Func(Of TEntity, Boolean))) As TEntity
        Function AddNew(entity As TEntity) As TEntity
        Function Update(entity As TEntity) As TEntity
        Sub Delete(entity As TEntity)

        ' new members that are required for the paging implementation
        Function GetAllWithoutDetaching() As IQueryable(Of TEntity) ' new
        Function DetachEntities(entities As IQueryable(Of TEntity)) As IEnumerable(Of TEntity) ' new

    End Interface

    Partial Public MustInherit Class OpenAccessBaseRepository(Of TEntity, TContext As {OpenAccessContext, New})
        Implements IOpenAccessBaseRepository(Of TEntity, TContext)

        Protected dataContext As New TContext()
        Protected fetchStrategy As New FetchStrategy()

        Public Overridable Function GetAll() As IQueryable(Of TEntity) Implements IOpenAccessBaseRepository(Of TEntity, TContext).GetAll
            Dim allEntities As List(Of TEntity) = dataContext.GetAll(Of TEntity)().ToList()

            Dim detachedEntities As List(Of TEntity) = dataContext.CreateDetachedCopy(Of List(Of TEntity))(allEntities, fetchStrategy)

            Return detachedEntities.AsQueryable()
        End Function

        Public Overridable Function GetBy(filter As Expression(Of Func(Of TEntity, Boolean))) As TEntity Implements IOpenAccessBaseRepository(Of TEntity, TContext).GetBy
            If filter Is Nothing Then
                Throw New ArgumentNullException("filter")
            End If

            Dim entity As TEntity = dataContext.GetAll(Of TEntity)().SingleOrDefault(filter)
            If entity Is Nothing Then
                Return Nothing
            End If

            Dim detachedEntity As TEntity = dataContext.CreateDetachedCopy(entity, fetchStrategy)

            Return detachedEntity
        End Function

        Public Overridable Function AddNew(entity As TEntity) As TEntity Implements IOpenAccessBaseRepository(Of TEntity, TContext).AddNew
            If entity Is Nothing Then
                Throw New ArgumentNullException("entity")
            End If

            Dim attachedEntity As TEntity = dataContext.AttachCopy(entity)
            dataContext.SaveChanges()

            Return attachedEntity
        End Function

        Public Overridable Function Update(entity As TEntity) As TEntity Implements IOpenAccessBaseRepository(Of TEntity, TContext).Update
            If entity Is Nothing Then
                Throw New ArgumentNullException("entity")
            End If

            Dim attachedEntity As TEntity = dataContext.AttachCopy(entity)
            dataContext.SaveChanges()

            Return attachedEntity
        End Function

        Public Overridable Sub Delete(entity As TEntity) Implements IOpenAccessBaseRepository(Of TEntity, TContext).Delete
            If entity Is Nothing Then
                Throw New ArgumentNullException("entity")
            End If

			Dim attachedEntity As TEntity = dataContext.AttachCopy(entity)
            dataContext.Delete(attachedEntity)
            dataContext.SaveChanges()
        End Sub

    End Class

End Namespace