﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.Web
Imports Newtonsoft.Json

Namespace WebApplication
    <JsonObject, DataContract>
    Public Class PagingResponse(Of T)
        Implements IEnumerable(Of T)

        Private totalCount As Long?
        Private result As IEnumerable(Of T)

        Public Sub New(ByVal result As IEnumerable(Of T), ByVal count? As Long)
            Me.totalCount = count
            Me.result = result
        End Sub

        <DataMember>
        Public ReadOnly Property Results() As IEnumerable(Of T)
            Get
                Return result
            End Get
        End Property

        <DataMember>
        Public Property Count() As Long?
            Get
                Return totalCount
            End Get
            Set(ByVal value As Long?)
                Me.totalCount = value
            End Set
        End Property

        Public Function GetEnumerator() As IEnumerator(Of T) Implements IEnumerable(Of T).GetEnumerator
            Return Me.result.GetEnumerator()
        End Function

        Private Function IEnumerable_GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return Me.result.GetEnumerator()
        End Function
    End Class
End Namespace
